Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3069)
+++ palm/trunk/SOURCE/Makefile	(revision 3083)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# add turbulence_closure_mod to parin
+# 
+# 2963 2018-04-12 14:47:44Z suehring
 # Introduce index for vegetation/wall, pavement/green-wall and water/window 
 # surfaces, for clearer access of surface fraction, albedo, emissivity, etc. .
@@ -1230,4 +1233,5 @@
 	spectra_mod.o \
 	synthetic_turbulence_generator_mod.o \
+	turbulence_closure_mod.o \
 	uv_exposure_model_mod.o \
 	vertical_nesting_mod.o \
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 3069)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 3083)
@@ -24,5 +24,8 @@
 ! Former revisions:
 ! -----------------
-! $Id$
+! $Id: check_parameters.f90 2520 2017-10-05 13:50:26Z gronemeier &
+! Add inital profile output for e (TG)
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! dz was replaced by dz(1), error message revised
 ! 
@@ -2455,9 +2458,14 @@
              ENDIF
 
-          CASE ( 'e' )
+          CASE ( 'e', '#e' )
              dopr_index(i)  = 8
              dopr_unit(i)   = 'm2/s2'
              hom(:,2,8,:)   = SPREAD( zu, 2, statistic_regions+1 )
              hom(nzb,2,8,:) = 0.0_wp
+             IF ( data_output_pr(i)(1:1) == '#' )  THEN
+                dopr_initial_index(i) = 8
+                hom(:,2,8,:)          = SPREAD( zu, 2, statistic_regions+1 )
+                data_output_pr(i)     = data_output_pr(i)(2:)
+             ENDIF
 
           CASE ( 'km', '#km' )
Index: palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/data_output_mask.f90	(revision 3069)
+++ palm/trunk/SOURCE/data_output_mask.f90	(revision 3083)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! 
+! 
+! 3045 2018-05-28 07:55:41Z Giersch
 ! Error messages revised
 ! 
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 3069)
+++ palm/trunk/SOURCE/header.f90	(revision 3083)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Print RANS-mode constants
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! Header output concerning stretching revised
 ! 
@@ -450,4 +453,7 @@
     USE synthetic_turbulence_generator_mod,                                    &
         ONLY:  stg_header
+
+    USE turbulence_closure_mod,                                                &
+        ONLY:  rans_const_c, rans_const_sigma
 
     IMPLICIT NONE
@@ -1946,5 +1952,7 @@
        IF ( wall_adjustment )  WRITE ( io, 453 )  wall_adjustment_factor
     ENDIF
-
+    IF ( rans_mode )  THEN
+       WRITE ( io, 457 )  rans_const_c, rans_const_sigma
+    ENDIF
 !
 !-- Special actions during the run
@@ -2388,4 +2396,11 @@
 456 FORMAT ('    Day of the year at model start :   day_init = ',I3             &
             /'    UTC time at model start        :   time_utc_init = ',F7.1' s')
+457 FORMAT ('    RANS-mode constants: c_0 = ',F9.5/         &
+            '                         c_1 = ',F9.5/         &
+            '                         c_2 = ',F9.5/         &
+            '                         c_3 = ',F9.5/         &
+            '                         c_4 = ',F9.5/         &
+            '                         sigma_e    = ',F9.5/  &
+            '                         sigma_diss = ',F9.5)
 470 FORMAT (//' Actions during the simulation:'/ &
               ' -----------------------------'/)
Index: palm/trunk/SOURCE/model_1d_mod.f90
===================================================================
--- palm/trunk/SOURCE/model_1d_mod.f90	(revision 3069)
+++ palm/trunk/SOURCE/model_1d_mod.f90	(revision 3083)
@@ -25,4 +25,21 @@
 ! -----------------
 ! $Id$
+! Bugfixes:
+!   - preset te_diss and te_e to avoid runtime errors
+!   - implementation of buoyancy term to dissipation
+!     according to Sogachev et al. (2012)
+!   - where diss_p < 0 set diss_p = 0.1 diss
+!   - calculate progn eq(diss) starting from nzb+1
+! Changes:
+!   - add sig_e to TKE equation
+!   - adjust prognostic equation of diss
+!   - set model constants according to Koblitz (2013)
+!   - renamed c_m to c_0
+!   - rename l_black into l1d_init
+!   - calculate l_grid within init_1d_model and save it as l1d_init
+!   - calculate l1d according to DE85 if dissipation is a prognostic value
+!   - made annotations doxygen-readable
+! 
+! 3049 2018-05-29 13:52:36Z Giersch
 ! Error messages revised
 ! 
@@ -164,5 +181,6 @@
     USE kinds
 
-    USE pegrid
+    USE pegrid,                                                                &
+        ONLY:  myid
         
 
@@ -175,10 +193,10 @@
     LOGICAL ::  stop_dt_1d = .FALSE.             !< termination flag, used in case of too small timestep (1d-model)
 
-    REAL(wp) ::  c_1 = 1.44_wp                 !< model constant
-    REAL(wp) ::  c_2 = 1.92_wp                 !< model constant
-    REAL(wp) ::  c_3 = 1.44_wp                 !< model constant
-    REAL(wp) ::  c_h = 0.0015_wp               !< model constant according to Detering and Etling (1985)
-    REAL(wp) ::  c_m = 0.4_wp                  !< model constant, 0.4 according to Detering and Etling (1985)
-    REAL(wp) ::  c_mu = 0.09_wp                !< model constant
+    REAL(wp) ::  alpha_buoyancy                !< model constant according to Koblitz (2013)
+    REAL(wp) ::  c_0 = 0.03_wp**0.25_wp        !< model constant according to Koblitz (2013)
+    REAL(wp) ::  c_1 = 1.52_wp                 !< model constant according to Koblitz (2013)
+    REAL(wp) ::  c_2 = 1.83_wp                 !< model constant according to Koblitz (2013)
+    REAL(wp) ::  c_3                           !< model constant
+    REAL(wp) ::  c_mu                          !< model constant
     REAL(wp) ::  damp_level_1d = -1.0_wp       !< namelist parameter
     REAL(wp) ::  dt_1d = 60.0_wp               !< dynamic timestep (1d-model)
@@ -187,7 +205,9 @@
     REAL(wp) ::  dt_run_control_1d = 60.0_wp   !< namelist parameter
     REAL(wp) ::  end_time_1d = 864000.0_wp     !< namelist parameter
+    REAL(wp) ::  lambda                        !< maximum mixing length
     REAL(wp) ::  qs1d                          !< characteristic humidity scale (1d-model)
     REAL(wp) ::  simulated_time_1d = 0.0_wp    !< updated simulated time (1d-model)
-    REAL(wp) ::  sig_diss = 1.3_wp             !< model constant
+    REAL(wp) ::  sig_diss = 2.95_wp            !< model constant according to Koblitz (2013)
+    REAL(wp) ::  sig_e = 2.95_wp               !< model constant according to Koblitz (2013)
     REAL(wp) ::  time_pr_1d = 0.0_wp           !< updated simulated time for profile output (1d-model)
     REAL(wp) ::  time_run_control_1d = 0.0_wp  !< updated simulated time for run-control output (1d-model)
@@ -198,5 +218,4 @@
     REAL(wp) ::  z01d                          !< roughness length for momentum (1d-model)
     REAL(wp) ::  z0h1d                         !< roughness length for scalars (1d-model)
-
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  diss1d   !< tke dissipation rate (1d-model)
@@ -279,6 +298,4 @@
 
     INTEGER(iwp) ::  k  !< loop index
-    
-    REAL(wp) ::  lambda !< maximum mixing length
 
 !
@@ -324,11 +341,11 @@
 !
 !--       Use the same mixing length as in 3D model (LES-mode)
-          !@todo: rename (delete?) this option
-          ! As the mixing length is different between RANS and LES mode, it
-          ! must be distinguished here between these modes. For RANS mode,
-          ! the mixing length is calculated accoding to Blackadar, which is
-          ! the other option at this point.
-          ! Maybe delete this option entirely (not appropriate in LES case)
-          ! 2018-03-20, gronemeier
+          !> @todo rename (delete?) this option
+          !>  As the mixing length is different between RANS and LES mode, it
+          !>  must be distinguished here between these modes. For RANS mode,
+          !>  the mixing length is calculated accoding to Blackadar, which is
+          !>  the other option at this point.
+          !>  Maybe delete this option entirely (not appropriate in LES case)
+          !>  2018-03-20, gronemeier
           DO  k = nzb+1, nzt
              l1d_init(k)  = ( dx * dy * dzw(k) )**0.33333333333333_wp
@@ -359,5 +376,5 @@
        us1d = 0.1_wp   ! without initial friction the flow would not change
     ELSE
-       diss1d(nzb+1) = 1.0_wp
+       diss1d(nzb+1) = 0.001_wp
        e1d(nzb+1)  = 1.0_wp
        km1d(nzb+1) = 1.0_wp
@@ -372,7 +389,8 @@
 
 !
-!-- Tendencies must be preset in order to avoid runtime errors within the
-!-- first Runge-Kutta step
+!-- Tendencies must be preset in order to avoid runtime errors
+    te_diss  = 0.0_wp
     te_dissm = 0.0_wp
+    te_e  = 0.0_wp
     te_em = 0.0_wp
     te_um = 0.0_wp
@@ -381,5 +399,6 @@
 !
 !-- Set model constant
-    IF ( dissipation_1d == 'as_in_3d_model' )  c_m = 0.1_wp
+    IF ( dissipation_1d == 'as_in_3d_model' )  c_0 = 0.1_wp
+    c_mu = c_0**4
 
 !
@@ -423,5 +442,5 @@
 !-- Determine the time step at the start of a 1D-simulation and
 !-- determine and printout quantities used for run control
-    dt_1d = 1.0_wp
+    dt_1d = 0.01_wp
     CALL run_control_1d
 
@@ -483,5 +502,5 @@
 !--             dissipation rate
                 IF ( dissipation_1d == 'detering' )  THEN
-                   diss1d(k) = c_m**3 * e1d(k) * SQRT( e1d(k) ) / l1d_diss(k)
+                   diss1d(k) = c_0**3 * e1d(k) * SQRT( e1d(k) ) / l1d_diss(k)
                 ELSEIF ( dissipation_1d == 'as_in_3d_model' )  THEN
                    diss1d(k) = ( 0.19_wp + 0.74_wp * l1d_diss(k) / l1d_init(k) &
@@ -497,5 +516,5 @@
                                      kmzp * ( e1d(k+1) - e1d(k) ) * ddzu(k+1)  &
                                    - kmzm * ( e1d(k) - e1d(k-1) ) * ddzu(k)    &
-                                                 ) * ddzw(k)                   &
+                                                 ) * ddzw(k) / sig_e           &
                                    - diss1d(k)
 
@@ -503,17 +522,24 @@
 !
 !--                dissipation rate
-                   te_diss(k) = km1d(k) *                                      &
+                   IF ( rif1d(k) >= 0.0_wp )  THEN
+                      alpha_buoyancy = 1.0_wp - l1d(k) / lambda
+                   ELSE
+                      alpha_buoyancy = 1.0_wp - ( 1.0_wp + ( c_2 - 1.0_wp )    &
+                                                         / ( c_2 - c_1    ) )  &
+                                              * l1d(k) / lambda
+                   ENDIF
+                   c_3 = ( c_1 - c_2 ) * alpha_buoyancy
+                   te_diss(k) = ( km1d(k) *                                    &
                                   ( ( ( u1d(k+1) - u1d(k-1) ) * dd2zu(k) )**2  &
                                   + ( ( v1d(k+1) - v1d(k-1) ) * dd2zu(k) )**2  &
-                                  ) * c_1 * c_mu**0.75 / c_h * f / us1d        &
-                                    * SQRT(e1d(k))                             &
+                                  ) * ( c_1 + (c_2 - c_1) * l1d(k) / lambda )  &
                                   - g / pt_0 * kh1d(k) * flux * c_3            &
-                                    * diss1d(k) / ( e1d(k) + 1.0E-20_wp )      &
-                                  + ( kmzp * ( diss1d(k+1) - diss1d(k) )       &
+                                  - c_2 * diss1d(k)                            &
+                                ) * diss1d(k) / ( e1d(k) + 1.0E-20_wp )        &
+                                + (   kmzp * ( diss1d(k+1) - diss1d(k) )       &
                                            * ddzu(k+1)                         &
                                     - kmzm * ( diss1d(k) - diss1d(k-1) )       &
                                            * ddzu(k)                           &
-                                    ) * ddzw(k) / sig_diss                     &
-                                  - c_2 * diss1d(k)**2 / ( e1d(k) + 1.0E-20_wp )
+                                  ) * ddzw(k) / sig_diss
 
                 ENDIF
@@ -546,5 +572,5 @@
 !--          dissipation rate
              IF ( dissipation_1d == 'detering' )  THEN
-                diss1d(k) = c_m**3 * e1d(k) * SQRT( e1d(k) ) / l1d_diss(k)
+                diss1d(k) = c_0**3 * e1d(k) * SQRT( e1d(k) ) / l1d_diss(k)
              ELSEIF ( dissipation_1d == 'as_in_3d_model' )  THEN
                 diss1d(k) = ( 0.19_wp + 0.74_wp * l1d_diss(k) / l1d_init(k) )  &
@@ -565,4 +591,8 @@
 !--          TKE
              IF ( .NOT. dissipation_1d == 'prognostic' )  THEN
+                !> @query why integrate over 2dz
+                !>   Why is it allowed to integrate over two delta-z for e
+                !>   while for u and v it is not?
+                !>   2018-04-23, gronemeier
                 te_e(k) = km1d(k) * ( ( ( u1d(k+1) - u1d(k-1) ) * dd2zu(k) )**2&
                                     + ( ( v1d(k+1) - v1d(k-1) ) * dd2zu(k) )**2&
@@ -572,5 +602,5 @@
                                      kmzp * ( e1d(k+1) - e1d(k) ) * ddzu(k+1)  &
                                    - kmzm * ( e1d(k) - e1d(k-1) ) * ddzu(k)    &
-                                                 ) * ddzw(k)                   &
+                                                 ) * ddzw(k) / sig_e           &
                                    - diss1d(k)
              ENDIF
@@ -595,10 +625,4 @@
              ENDDO
 
-             IF ( dissipation_1d == 'prognostic' )  THEN
-                DO  k = nzb_diff, nzt
-                   diss1d_p(k) = diss1d(k) + dt_1d * ( tsc(2) * te_diss(k) + &
-                                                 tsc(3) * te_dissm(k) )
-                ENDDO
-             ENDIF
 !
 !--          Eliminate negative TKE values, which can result from the
@@ -606,4 +630,12 @@
 !--          value is reduced to 10 percent of its old value.
              WHERE ( e1d_p < 0.0_wp )  e1d_p = 0.1_wp * e1d
+
+             IF ( dissipation_1d == 'prognostic' )  THEN
+                DO  k = nzb+1, nzt
+                   diss1d_p(k) = diss1d(k) + dt_1d * ( tsc(2) * te_diss(k) + &
+                                                       tsc(3) * te_dissm(k) )
+                ENDDO
+                WHERE ( diss1d_p < 0.0_wp )  diss1d_p = 0.1_wp * diss1d
+             ENDIF
           ENDIF
 
@@ -643,5 +675,6 @@
                    IF ( dissipation_1d == 'prognostic' )  THEN
                       DO k = nzb+1, nzt
-                         te_dissm(k) = -9.5625_wp * te_diss(k) + 5.3125_wp * te_dissm(k)
+                         te_dissm(k) = -9.5625_wp * te_diss(k)  &
+                                     +  5.3125_wp * te_dissm(k)
                       ENDDO
                    ENDIF
@@ -650,5 +683,4 @@
              ENDIF
           ENDIF
-
 
 !
@@ -701,5 +733,8 @@
 
              ENDIF    ! constant_flux_layer
-
+             !> @todo combine if clauses
+             !>   The previous and following if clauses can be combined into a
+             !>   single clause
+             !>   2018-04-23, gronemeier
 !
 !--          Compute the Richardson-flux numbers,
@@ -789,8 +824,8 @@
 !--             compatibility with the 3D model.
                 IF ( ibc_e_b == 2 )  THEN
-                   e1d(nzb+1) = ( us1d / c_m )**2
+                   e1d(nzb+1) = ( us1d / c_0 )**2
                 ENDIF
                 IF ( dissipation_1d == 'prognostic' )  THEN
-                   e1d(nzb+1) = us1d**2 / SQRT( c_mu )
+                   e1d(nzb+1) = ( us1d / c_0 )**2
                    diss1d(nzb+1) = us1d**3 / ( kappa * zu(nzb+1) )
                    diss1d(nzb) = diss1d(nzb+1)
@@ -829,26 +864,33 @@
 !--          in the dissipation of TKE via l1d_diss. Otherwise, km1d would be
 !--          too large.
-             IF ( mixing_length_1d == 'blackadar' )  THEN
+             IF ( dissipation_1d /= 'prognostic' )  THEN
+                IF ( mixing_length_1d == 'blackadar' )  THEN
+                   DO  k = nzb+1, nzt
+                      IF ( rif1d(k) >= 0.0_wp )  THEN
+                         l1d(k) = l1d_init(k) / ( 1.0_wp + 5.0_wp * rif1d(k) )
+                         l1d_diss(k) = l1d(k)
+                      ELSE
+                         l1d(k) = l1d_init(k)
+                         l1d_diss(k) = l1d_init(k) *                           &
+                                       SQRT( 1.0_wp - 16.0_wp * rif1d(k) )
+                      ENDIF
+                   ENDDO
+                ELSEIF ( mixing_length_1d == 'as_in_3d_model' )  THEN
+                   DO  k = nzb+1, nzt
+                      dpt_dz = ( pt_init(k+1) - pt_init(k-1) ) * dd2zu(k)
+                      IF ( dpt_dz > 0.0_wp )  THEN
+                         l_stable = 0.76_wp * SQRT( e1d(k) )                   &
+                                  / SQRT( g / pt_init(k) * dpt_dz ) + 1E-5_wp
+                      ELSE
+                         l_stable = l1d_init(k)
+                      ENDIF
+                      l1d(k) = MIN( l1d_init(k), l_stable )
+                      l1d_diss(k) = l1d(k)
+                   ENDDO
+                ENDIF
+             ELSE
                 DO  k = nzb+1, nzt
-                   IF ( rif1d(k) >= 0.0_wp )  THEN
-                      l1d(k) = l1d_init(k) / ( 1.0_wp + 5.0_wp * rif1d(k) )
-                      l1d_diss(k) = l1d(k)
-                   ELSE
-                      l1d(k) = l1d_init(k)
-                      l1d_diss(k) = l1d_init(k) *                              &
-                                    SQRT( 1.0_wp - 16.0_wp * rif1d(k) )
-                   ENDIF
-                ENDDO
-             ELSEIF ( mixing_length_1d == 'as_in_3d_model' )  THEN
-                DO  k = nzb+1, nzt
-                   dpt_dz = ( pt_init(k+1) - pt_init(k-1) ) * dd2zu(k)
-                   IF ( dpt_dz > 0.0_wp )  THEN
-                      l_stable = 0.76_wp * SQRT( e1d(k) ) /                    &
-                                     SQRT( g / pt_init(k) * dpt_dz ) + 1E-5_wp
-                   ELSE
-                      l_stable = l1d_init(k)
-                   ENDIF
-                   l1d(k) = MIN( l1d_init(k), l_stable )
-                   l1d_diss(k) = l1d(k)
+                   l1d(k) = c_0**3 * e1d(k) * SQRT( e1d(k) )                   &
+                          / ( diss1d(k) + 1.0E-30_wp )
                 ENDDO
              ENDIF
@@ -867,4 +909,5 @@
                 ENDIF
              ENDIF
+
              IF ( dissipation_1d == 'prognostic' )  THEN
                 DO  k = nzb_diff, nzt
@@ -873,5 +916,5 @@
              ELSE
                 DO  k = nzb_diff, nzt
-                   km1d(k) = c_m * SQRT( e1d(k) ) * l1d(k)
+                   km1d(k) = c_0 * SQRT( e1d(k) ) * l1d(k)
                 ENDDO
              ENDIF
@@ -1018,11 +1061,16 @@
 
     REAL(wp) ::  dt_diff  !< time step accorind to diffusion criterion
+    REAL(wp) ::  dt_old   !< previous time step
     REAL(wp) ::  fac      !< factor of criterion
     REAL(wp) ::  value    !< auxiliary variable
 
 !
+!-- Save previous time step
+    dt_old = dt_1d
+
+!
 !-- Compute the currently feasible time step according to the diffusion
 !-- criterion. At nzb+1 the half grid length is used.
-    fac = 0.125  !0.35_wp                                                       !### changed from 0.35
+    fac = 0.125
     dt_diff = dt_max_1d
     DO  k = nzb+2, nzt
@@ -1034,6 +1082,10 @@
 
 !
+!-- Limit the new time step to a maximum of 10 times the previous time step
+    dt_1d = MIN( dt_old * 10.0_wp, dt_1d )
+
+!
 !-- Set flag when the time step becomes too small
-    IF ( dt_1d < ( 0.00001_wp * dt_max_1d ) )  THEN
+    IF ( dt_1d < ( 1.0E-15_wp * dt_max_1d ) )  THEN
        stop_dt_1d = .TRUE.
 
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 3069)
+++ palm/trunk/SOURCE/modules.f90	(revision 3083)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! set dt_3d = 0.01
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! Variables concerning stretching introduced or revised
 ! 
@@ -1422,5 +1425,5 @@
     REAL(wp) ::  dt_run_control = 60.0_wp                      !< namelist parameter
     REAL(wp) ::  dt_spinup = 60.0_wp                           !< namelist parameter
-    REAL(wp) ::  dt_3d = 1.0_wp                                !< time step
+    REAL(wp) ::  dt_3d = 0.01_wp                               !< time step
     REAL(wp) ::  dz_max = 1000.0_wp                            !< namelist parameter
     REAL(wp) ::  dz_stretch_factor = 1.08_wp                   !< namelist parameter
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 3069)
+++ palm/trunk/SOURCE/parin.f90	(revision 3083)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Added rans_const_c and rans_const_sigma as input parameters (TG)
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! New initialization parameters added
 ! 
@@ -467,4 +470,7 @@
     USE synthetic_turbulence_generator_mod,                                    &
         ONLY:  stg_parin
+
+    USE turbulence_closure_mod,                                                &
+        ONLY:  rans_const_c, rans_const_sigma
 
     USE urban_surface_mod,                                                     &
@@ -531,5 +537,6 @@
              pt_vertical_gradient_level, q_surface, q_surface_initial_change,  &
              q_vertical_gradient, q_vertical_gradient_level,                   &
-             random_generator, random_heatflux, rans_mode,                     &
+             random_generator, random_heatflux, rans_const_c, rans_const_sigma,&
+             rans_mode,                                                        &
              rayleigh_damping_factor, rayleigh_damping_height,                 &
              recycling_width, recycling_yshift,                                &
@@ -601,5 +608,6 @@
              pt_vertical_gradient_level, q_surface, q_surface_initial_change,  &
              q_vertical_gradient, q_vertical_gradient_level,                   &
-             random_generator, random_heatflux, rans_mode,                     &
+             random_generator, random_heatflux, rans_const_c, rans_const_sigma,&
+             rans_mode,                                                        &
              rayleigh_damping_factor, rayleigh_damping_height,                 &
              recycling_width, recycling_yshift,                                &
Index: palm/trunk/SOURCE/timestep.f90
===================================================================
--- palm/trunk/SOURCE/timestep.f90	(revision 3069)
+++ palm/trunk/SOURCE/timestep.f90	(revision 3083)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! limit dt_3d to be at maximum 2*old_dt; define old_dt at beginning of routine
+! Add km/kh_max
+! 
+! 3049 2018-05-29 13:52:36Z Giersch
 ! Error messages revised
 ! 
@@ -161,4 +165,6 @@
     INTEGER(iwp) ::  j !< 
     INTEGER(iwp) ::  k !< 
+    INTEGER(iwp) ::  km_max_ijk(3) = -1  !< index values (i,j,k) of location where km_max occurs
+    INTEGER(iwp) ::  kh_max_ijk(3) = -1  !< index values (i,j,k) of location where kh_max occurs
 
     LOGICAL ::  stop_dt_local !< local switch for controlling the time stepping
@@ -173,4 +179,6 @@
     REAL(wp) ::  dt_w              !< 
     REAL(wp) ::  dt_w_l            !< 
+    REAL(wp) ::  km_max            !< maximum of Km in entire domain
+    REAL(wp) ::  kh_max            !< maximum of Kh in entire domain
     REAL(wp) ::  u_gtrans_l        !< 
     REAL(wp) ::  u_max_l           !< 
@@ -190,6 +198,8 @@
 
 
-
     CALL cpu_log( log_point(12), 'calculate_timestep', 'start' )
+!
+!--    Save former time step as reference
+       old_dt = dt_3d
 
 !
@@ -318,7 +328,8 @@
 !--    The time step is the minimum of the 3-4 components and the diffusion time
 !--    step minus a reduction (cfl_factor) to be on the safe side.
-!--    The time step must not exceed the maximum allowed value.
+!--    The time step must not exceed the maximum allowed value and must not
+!--    increase by more than a factor of 10.
        dt_3d = cfl_factor * MIN( dt_diff, dt_u, dt_v, dt_w, dt_precipitation )
-       dt_3d = MIN( dt_3d, dt_max )
+       dt_3d = MIN( dt_3d, dt_max, 2.0_wp * old_dt )
 
 !
@@ -334,4 +345,12 @@
        IF ( dt_3d < ( 0.00001_wp * dt_max ) )  THEN
           stop_dt = .TRUE.
+
+!
+!--       Determine the maxima of the diffusion coefficients, including their
+!--       grid index positions.
+          CALL global_min_max( nzb, nzt+1, nysg, nyng, nxlg, nxrg, km, 'abs',  &
+                               0.0_wp, km_max, km_max_ijk )
+          CALL global_min_max( nzb, nzt+1, nysg, nyng, nxlg, nxrg, kh, 'abs',  &
+                               0.0_wp, kh_max, kh_max_ijk )
 
           WRITE( message_string, * ) 'Time step has reached minimum limit.',   &
@@ -342,10 +361,14 @@
                '&dt_w            = ', dt_w, ' s',                              &
                '&dt_diff         = ', dt_diff, ' s',                           &
-               '&u_max           = ', u_max, ' m/s   k=', u_max_ijk(1),        &
+               '&u_max           = ', u_max, ' m/s    k=', u_max_ijk(1),       &
                '  j=', u_max_ijk(2), '  i=', u_max_ijk(3),                     &
-               '&v_max           = ', v_max, ' m/s   k=', v_max_ijk(1),        &
+               '&v_max           = ', v_max, ' m/s    k=', v_max_ijk(1),       &
                '  j=', v_max_ijk(2), '  i=', v_max_ijk(3),                     &
-               '&w_max           = ', w_max, ' m/s   k=', w_max_ijk(1),        &
-               '  j=', w_max_ijk(2), '  i=', w_max_ijk(3)
+               '&w_max           = ', w_max, ' m/s    k=', w_max_ijk(1),       &
+               '  j=', w_max_ijk(2), '  i=', w_max_ijk(3),                     &
+               '&km_max          = ', km_max, ' m2/s2  k=', km_max_ijk(1),     &
+               '  j=', km_max_ijk(2), '  i=', km_max_ijk(3),                   &
+               '&kh_max          = ', kh_max, ' m2/s2  k=', kh_max_ijk(1),     &
+                '  j=', kh_max_ijk(2), '  i=', kh_max_ijk(3)
           CALL message( 'timestep', 'PA0312', 0, 1, 0, 6, 0 )
 !
@@ -388,8 +411,4 @@
        dt_3d = NINT( dt_3d * 100.0_wp / div ) * div / 100.0_wp
 
-!
-!--    Adjust the time step
-       old_dt = dt_3d
-
     ENDIF
 
